package body Railroad.Station is

   --+------------------------------
   --  THE STATION CLASS
   --+------------------------------

   protected body Station_T is
      --  calls to Arrive at one departing Station succed
      --+ when the Train is ready to board Travelers at that Station
      entry Arrive (Destination : Address_T;
                    Traveler    : Positive)
         when Trainboarding and then Transported < Capacity is
      begin
         --  if so, then the count of traveling Travelers
         --+ increases by 1
         Transported := Transported + 1;
         En_Route (Traveler) := True;
         --  and the Traveler is requeded (and blocked)
         --+ on the destination Station
         requeue Railway_Line (Destination).Alight;
      end Arrive;
      --+--------
      --  the Train stops at a Station declaring its current load and
      --+ allowing the Travelers arrived at their destination to disembark
      procedure Stopping (P : Passengers_T) is
      begin
         Transported := P;
         Trainstopped := True;
      end Stopping;
      --+----------
      --  all Travelers queued on Alight at the Station where the Train
      --+ has stopped are allowed to get off
      entry Alight (Destination : Address_T;
                    Traveler    : Positive) when Trainstopped is
      begin
         --  and for each one the count of traveling Travelers decrements by 1
         Transported := Transported - 1;
         En_Route (Traveler) := False;
      end Alight;
      --+--------
      --  the Train calls Boarding to stop any new Traveler from
      --+ arriving before even departing and then to allow Travelers
      --+ departing from that Station to board the Train
      procedure Boarding is
      begin
         Trainstopped  := False;
         Trainboarding := True;
      end Boarding;
      --+----------
      --  the Train calls Closedoors to update the count of
      --+ traveling Travelers and to stop boarding new Travelers
      procedure Closedoors (P :    out Passengers_T) is
      begin
         P := Transported;
         Trainboarding := False;
      end Closedoors;
      --+------------
   end Station_T;

end Railroad.Station;
