package Railroad.Station is

   --+------------------------------
   --  THE STATION CLASS
   --+------------------------------

   protected type Station_T is
      --  travelers call Arrive when they get to the departure station
      entry Arrive (Destination : Address_T;
                    Traveler    : Positive);
      --  the train calls Stopping when it gets to the station
      procedure Stopping (P : Passengers_T);
      --  the station requeues passengers to their destination
      --  station if the train capacity is not exhausted
      entry Alight (Destination : Address_T;
                    Traveler    : Positive);
      --  the train calls Boarding when it is ready to board travelers
      procedure Boarding;
      --  the train calls Closedoors to board passengers at the station
      procedure Closedoors (P :    out Passengers_T);
   private
      --  the travelers being transported
      Transported : Passengers_T := 0;
      --  train willing to board travelers
      Trainboarding : Boolean := False;
      --  train calling at a station
      Trainstopped  : Boolean := False;
   end Station_T;

   --+---------------------------------
   --  THE ACTUAL RAILWAY LINE
   --+ a ring with one Station per stop
   --+---------------------------------
   Railway_Line : array (Address_T) of Station_T;

end Railroad.Station;
